{project CopySort - Version 1.3

 Delphi 16 y 32

 14.06.97

 Autor
    (c)J.M.Gas    Zaragoza - Espaa
    email  : j.m.gias@arrakis.es
    Freeware  - Esto es un ejemplo por lo que no se admiten reclamaciones ni se
                ofrece garantias de ninguna clase.

 Copia, Ordena, Exporta, Filtra, Query, Print, Indexa, Empaqueta, Info BDE,
 Estructura de Tablas y de Indices, Visor de Datos, etc.

 En el Project se muestra un ejemplo de como realizar algunas funciones que en
 dBase eran muy sencillas y habituales, pero que en Delphi se han complicado y
 lo que es peor, estn escsamente documentadas.

 Con el proyecto de demo que se adjunta, se pueden realizar las siguientes
 funciones:

 - CopyTablefull(..) Utiliza la funcion del BDE dbiCopyTable() que hace una
                     copia integra de la tabla aunque est filtrada

    - Copiar o duplicar tablas completas con sus Indices

 - SortTable(..) Utiliza componentes Ttable y BatchMove

   - Ordenar tablas

 - CopySort(..) Utiliza componentes Ttable

    - Copiar o duplicar tablas completas sin Indices.

    - Copiar datos a otra tabla de forma ordenada

    - Exportar datos ordenados por un Indice a dBase, Paradox, o ASCII .Txt
      (Ojo. Si se exporta en formato ASCII, los campos Memo no son soportados
       y dar un error)

 En esta versin se han incorporado varias funciones y un Menu y se han separado
 los diferentes procedimientos para mayor comprensin.

 Todos los Mail con comentarios y correcciones al ejemplo sern sumamente
 agradecidos y redundarn en beneficio de la comunidad de desarrolladores de Delphi.

 El encapsular estas funciones y otras de similares caractersticas en componentes
 sera una labor interesante. Os invito a continuar el trabajo.

 El autor agradecera el que envieis vuestros ejemplos de aplicaciones
 para intercambiar experiencias de desarrollo y conocimientos.

}

unit Cp_so3sp;

interface

uses {$IFDEF WIN32} BDE,Windows,ComCtrls,{$ELSE}Winprocs,{$ENDIF}
  SysUtils, WinTypes, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, DB, DBTables, DbiProcs, DbiErrs,
  DbiTypes, DBConsts, ExtCtrls, Mask, Grids, DBGrids, FileCtrl, DBCtrls,
  TabNotBk,Menus,Printers;

type
  TCopia_Dbf = class(TForm)
    Table1: TTable;
    Table2: TTable;
    DS1: TDataSource;
    DS2: TDataSource;
    Query1: TQuery;
    DataSource1: TDataSource;
    TN1: TTabbedNotebook;
    DBNavigator1: TDBNavigator;
    DBGrid1: TDBGrid;
    Label6: TLabel;
    CbTipoTabla: TComboBox;
    Label5: TLabel;
    EditFic: TEdit;
    EditDirectory: TEdit;
    Label3: TLabel;
    DriveComboBox1: TDriveComboBox;
    Directory1: TDirectoryListBox;
    Panel1: TPanel;
    Edit1: TEdit;
    Edit2: TEdit;
    DBNavigator2: TDBNavigator;
    DBGrid2: TDBGrid;
    BMove1: TBatchMove;
    MainMenu1: TMainMenu;
    Copiar1: TMenuItem;
    TablassinIndices1: TMenuItem;
    TablasIndices1: TMenuItem;
    Exportar1: TMenuItem;
    Tablaordebnada1: TMenuItem;
    FiltroSQL1: TMenuItem;
    Ordenar1: TMenuItem;
    TablaporunIndice1: TMenuItem;
    Ver1: TMenuItem;
    Filtros1: TMenuItem;
    Salida1: TMenuItem;
    Sql1: TMenuItem;
    Query2: TMenuItem;
    Utilidades1: TMenuItem;
    Indexar1: TMenuItem;
    Empaquetar1: TMenuItem;
    Acercade1: TMenuItem;
    Salir1: TMenuItem;
    Estructura1: TMenuItem;
    SQL2: TMenuItem;
    Ejecutar1: TMenuItem;
    Memo2: TMemo;
    Memo1: TMemo;
    Label8: TLabel;
    EditRecordQuery: TEdit;
    Label10: TLabel;
    Label9: TLabel;
    BBSql: TBitBtn;
    Label12: TLabel;
    Buffer: TEdit;
    Heap: TEdit;
    Controladores: TEdit;
    Clientes: TEdit;
    Sesiones: TEdit;
    BasesDatos: TEdit;
    Cursores: TEdit;
    Compartir: TEdit;
    TipoRed: TEdit;
    NombreUsuario: TEdit;
    ArchivoConfiguracion: TEdit;
    ControladorLenguaje: TEdit;
    Timer1: TTimer;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    GroupBox1: TGroupBox;
    CBAlias: TComboBox;
    Label2: TLabel;
    CBTable: TComboBox;
    Label7: TLabel;
    EditRegistros: TEdit;
    Label4: TLabel;
    CBIndex: TComboBox;
    EditAlias: TEdit;
    EditTable: TEdit;
    EditIndex: TEdit;
    Label1: TLabel;
    Label11: TLabel;
    Label13: TLabel;
    Database1: TDatabase;
    Label14: TLabel;
    Imprimir1: TMenuItem;
    PrintSql: TBitBtn;
    EditRegistro: TEdit;
    Label18: TLabel;
    CheckBox1: TCheckBox;
    SGrid1: TStringGrid;
    EditNear: TEdit;
    Label15: TLabel;
    Label16: TLabel;
    EditRanStart: TEdit;
    Label17: TLabel;
    EditRanEnd: TEdit;
    SpeedButton1: TSpeedButton;
    N1: TMenuItem;
    IndexInfo: TComboBox;
    Label19: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure CBAliasChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure CBTableChange(Sender: TObject);
    procedure EditFicKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure DirectoryEnter(Sender: TObject);
    procedure DirectoryExit(Sender: TObject);
    procedure RbCopySortKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure CBAliasKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure CBTableKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure CBIndexKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure CBAliasEnter(Sender: TObject);
    procedure CBAliasExit(Sender: TObject);
    procedure CBTableEnter(Sender: TObject);
    procedure CBTableExit(Sender: TObject);
    procedure CBIndexEnter(Sender: TObject);
    procedure CBIndexExit(Sender: TObject);
    procedure RbCopiarSoloDatosKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure RbCopiarTodoKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure CbTipoTablaEnter(Sender: TObject);
    procedure CbTipoTablaExit(Sender: TObject);
    procedure CbTipoTablaKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Directory1Change(Sender: TObject);
    procedure BBSQLClick(Sender: TObject);
    procedure TN1Click(Sender: TObject);
    procedure TablassinIndices1Click(Sender: TObject);
    procedure TablaporunIndice1Click(Sender: TObject);
    procedure FiltroSQL1Click(Sender: TObject);
    procedure Tablaordebnada1Click(Sender: TObject);
    procedure TablasIndices1Click(Sender: TObject);
    procedure Ejecutar1Click(Sender: TObject);
    procedure Salir1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure CBIndexChange(Sender: TObject);
    procedure Filtros1Click(Sender: TObject);
    procedure Sql1Click(Sender: TObject);
    procedure Query2Click(Sender: TObject);
    procedure Estructura1Click(Sender: TObject);
    procedure Explorer1Click(Sender: TObject);
    procedure Indexar1Click(Sender: TObject);
    procedure Empaquetar1Click(Sender: TObject);
    procedure Acercade1Click(Sender: TObject);
    procedure DS1DataChange(Sender: TObject; Field: TField);
    procedure CheckBox1Click(Sender: TObject);
    procedure EditNearChange(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure EditRanStartKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure PrintSqlClick(Sender: TObject);
    procedure Imprimir1Click(Sender: TObject);
  public
    Contador,NTablas,k : Integer;
    Retorno,Alias_S,Table_S,Index_S,Directory_T,Table_T : String;
    TableType_T : TTableType;
    function Ltrim(Cadena: string): string;
    function Rtrim(Cadena: string): string;
    function Alltrim(Cadena: string): string;
    function Space(I: Integer): string;
    function AlineaIzqda(Cadena: string;K:Integer): string;
    function SortTable(Alias_S,Table_S,Index_S :String; var Retorno :String):Boolean;
    function CopySort(Alias_S,Table_S,Index_S,Directory_T,Table_T :String;
                      var Retorno :String; TableType_T : TTableType):Boolean;
    function CopyTableFull(Alias_S, Table_S, Table_T: String; var Retorno :String): Boolean;
    function fDbiPackTable(TblName : TTable; bRegenIdxs: Boolean; var Retorno : String): Boolean;
    function fDbiRegenIndexes(TblName : TTable ; var Retorno : String): Boolean;
    function fDbiSortTable(SrcTbl, DestTbl: TTable; SortField: TField): longint;
    function GetFieldType(Tipo: TFieldType): string;
    function Recno(ATable: TTable): Longint;
    procedure InicioCopia;
    procedure Mensaje(Escribe : String);
    procedure HandleExcepcion(Sender: TObject; E: Exception);

  end;

var
  Copia_Dbf  : TCopia_Dbf;
  RecordToCopy, RecordCopy : Integer;

implementation

{$R *.DFM}

procedure TCopia_Dbf.HandleExcepcion(Sender: Tobject; E: Exception);
begin
  if E.Message <> '' then begin
    Screen.Cursor := crArrow;
    MessageDlg(E.Message, mtError, [mbOK], 0);
  end;
end;

{#  Elimina los espacios a la izquierda de una cadena
 ## Eliminate the spaces to the left from a string}
function TCopia_Dbf.Ltrim(Cadena: string): string;
begin
 while pos(' ',Cadena) = 1 do begin
  Cadena := Copy(Cadena,2,Length(Cadena)-1);
 end;
 Result:= Cadena;
end;

{#  Elimina los espacios a la derecha de una cadena
 ## Eliminate the spaces to the right from a chain
}
function TCopia_Dbf.Rtrim(Cadena: string): string;
begin
 while Copy(Cadena,Length(Cadena),1) = ' ' do begin
  Cadena := Copy(Cadena,1,Length(Cadena) - 1);
 end;
 Result:= Cadena;
end;

{#  Elimina los espacios a la Izqda. y derecha de una cadena
 ## Eliminate the spaces to the left and right from a chain}
function TCopia_Dbf.Alltrim(Cadena: string): string;
begin
 Result:= Ltrim(Rtrim(Cadena));
end;

{ Inserta I espacios }
function TCopia_Dbf.Space(I: Integer): String;
var
 k      : Integer;
 Cadena : string;
begin
  k      := 0;
  Cadena := '';
  while k < I do begin
    Cadena := Cadena + ' ';
    k      := K + 1;
  end;
  Result := Cadena;
end;

{ Alinea a la Izquierda rellenando espacios hasta completar longitud K }
function TCopia_Dbf.AlineaIzqda(Cadena: string;K: Integer): string;
begin
  if k = 0 then k := Length(Cadena);
  if k < Length(Cadena) then k := Length(Cadena);
  Cadena := Ltrim(Cadena);
  Cadena := Cadena + Space(k - Length(Cadena));
  Result := Cadena;
end;

procedure TCopia_Dbf.Mensaje(Escribe : String);
begin
 Edit1.Text := Escribe;
 Edit1.Refresh;
end;

procedure TCopia_Dbf.FormCreate(Sender: TObject);
var
 K : Integer;
begin
 Application.OnException := HandleExcepcion;
 Screen.Cursor           := CrHourGlass;
 try
  Session.GetAliasNames(CbAlias.Items);
  CbAlias.ItemIndex := 0;
 finally
  Screen.Cursor     := CrDefault;
 end;

 {Lanzar los procedimientos de actualizacin de datos}
 CbAliasChange(nil);
 CbTipoTabla.ItemIndex := 0;
 EditDirectory.Text    := Directory1.Directory;
 if Copy(EditDirectory.Text,Length(EditDirectory.Text),1) <> '\'
 then EditDirectory.Text := EditDirectory.Text + '\';

 SGrid1.Cells[0,0]   := 'Campos';
 SGrid1.Cells[1,0]   := 'Tipo';
 SGrid1.Cells[2,0]   := 'Tamao';
 SGrid1.Cells[3,0]   := 'Requerido';
 SGrid1.ColWidths[0] := Round(SGrid1.DefaultColWidth * 1.65);
 SGrid1.ColWidths[2] := Round(SGrid1.DefaultColWidth / 1.5);
 SGrid1.ColWidths[3] := Round(SGrid1.DefaultColWidth / 1.5);
 sGrid1.Width        := 379;
end;

procedure TCopia_Dbf.CBAliasChange(Sender: TObject);
begin
 Screen.Cursor       := CrHourGlass;
 try
  with CbAlias do
   Session.GetTableNames(Items[ItemIndex],'',True,False,CbTable.Items);
   CbTable.Items.Insert(0, '< Todas las Tablas >');
   CbTable.ItemIndex := 0;
   EditAlias.Text    := CbAlias.Items[CbAlias.ItemIndex];
 finally
  Screen.Cursor      := CrDefault;
 end;
 sGrid1.RowCount   := 2;
 sGrid1.Cells[0,1] := '';
 sGrid1.Cells[1,1] := '';
 sGrid1.Cells[2,1] := '';
 sGrid1.Cells[3,1] := '';
end;

procedure TCopia_Dbf.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Release;
end;

procedure TCopia_Dbf.CBTableChange(Sender: TObject);
var
 k       : integer;
 Table_S : String;
begin
 {Refrescar datos al cambiar de tabla}
 Screen.Cursor         := CrHourGlass;
 CbTable.Refresh;
 if CbTable.ItemIndex > 0 then begin
  try
   k := 1;
   while CbIndex.Items[k] <> '' do CbIndex.Items.Delete(k);

   Table1.Close;
   Table1.DatabaseName := CbAlias.Items[CbAlias.ItemIndex];
   Table1.TableName    := CbTable.Items[CbTable.ItemIndex];
   Table1.IndexName    := '';
   Table1.Open;
   Table1.Active       := True;
   EditRegistros.Text  := IntToStr(Table1.RecordCount);
   Table1.GetIndexNames(CbIndex.Items);

   {Pasar la caracterstica de los campos al grid}
   SGrid1.Cells[0,0] := 'Campos';
   SGrid1.Cells[1,0] := 'Tipo';
   SGrid1.Cells[2,0] := 'Tamao';
   SGrid1.Cells[3,0] := 'Requerido';
   SGrid1.RowCount := Table1.FieldCount + 1;
   for K := 0 to Table1.FieldCount - 1 do begin
    SGrid1.Cells[0,k+1] := Table1.FieldDefs.Items[k].Name;
    SGrid1.Cells[1,k+1] := GetFieldType(Table1.FieldDefs.Items[k].DataType);

    case Table1.FieldDefs.Items[k].DataType of
     ftString, ftBCD, ftBytes, ftVarBytes, ftBlob,
     ftMemo , ftGraphic : SGrid1.Cells[2,k+1] := IntToStr(Table1.FieldDefs.Items[K].Size);
    else
     SGrid1.Cells[2,k+1] := '';
    end;
    if Table1.FieldDefs.Items[K].Required then SGrid1.Cells[3,k+1] := 'True'
    else SGrid1.Cells[3,k+1] := 'False';
   end;

   Table1.Close;

   if CbIndex.Items[0] <> '< Orden Natural >' then
    CbIndex.Items.Insert(0, '< Orden Natural >');

   CbIndex.ItemIndex := 0;
   EditTable.Text    := CbTable.Items[CbTable.ItemIndex];
   EditIndex.Text    := '< Orden Natural >';
  finally
   Screen.Cursor      := CrDefault;
  end;
 end;
 Screen.Cursor      := CrDefault;

 {Configurar la cabecera del texto SQL y la informacin de tablas y campos}
 if CbTable.Items[CbTable.ItemIndex] <> '< Todas las Tablas >' then begin
  Memo1.Text := '';
  Memo1.Lines.Add('Select * ');
  Table_S := CbTable.Items[CbTable.ItemIndex];
  if Pos('.',Table_S) > 0 then Table_S := Copy(Table_S,1,Pos('.',Table_S)-1);
  Memo1.Lines.Add('From ' + Table_S);
  Memo1.Lines.Add('Where ');
  Memo1.Lines.Add(' Like ' + Chr(39) + '%%' + Chr(39));
 end;
end;

procedure TCopia_Dbf.EditFicKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if Key = VK_RETURN then CbTipoTabla.SetFocus;
end;

procedure TCopia_Dbf.DirectoryEnter(Sender: TObject);
begin
 Directory1.Color := clWhite;
end;

procedure TCopia_Dbf.DirectoryExit(Sender: TObject);
begin
 Directory1.Color := clSilver;
end;

procedure TCopia_Dbf.RbCopySortKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if Key = VK_RETURN then CbAlias.SetFocus;
end;

procedure TCopia_Dbf.CBAliasKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if Key = VK_RETURN then CbTable.SetFocus;
end;

procedure TCopia_Dbf.CBTableKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if (Key = VK_RETURN)then Directory1.SetFocus
 else CbIndex.SetFocus;
end;

procedure TCopia_Dbf.CBIndexKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if Key = VK_RETURN then EditFic.SetFocus;
end;

procedure TCopia_Dbf.CBAliasEnter(Sender: TObject);
begin
 CbAlias.Color := clWhite;
end;

procedure TCopia_Dbf.CBAliasExit(Sender: TObject);
begin
 CbAlias.Color := clSilver;
end;

procedure TCopia_Dbf.CBTableEnter(Sender: TObject);
begin
 CbTable.Color := clWhite;
end;

procedure TCopia_Dbf.CBTableExit(Sender: TObject);
begin
 CbTable.Color := clSilver;
end;

procedure TCopia_Dbf.CBIndexEnter(Sender: TObject);
begin
 CbIndex.Color := clWhite;
end;

procedure TCopia_Dbf.CBIndexExit(Sender: TObject);
begin
 CbIndex.Color := clSilver;
end;

procedure TCopia_Dbf.RbCopiarSoloDatosKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if Key = VK_RETURN then CbAlias.SetFocus;
end;

procedure TCopia_Dbf.RbCopiarTodoKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if Key = VK_RETURN then CbAlias.SetFocus;
end;

function TCopia_Dbf.SortTable(Alias_S,Table_S,Index_S :String;var Retorno :String):Boolean;
var
 Field_Number : Integer;
begin

 {Ctrl. Alias}
 if Length(Alias_S) = 0 then begin
  Retorno := ('Debe seleccionarse el Alias de los datos.');
  Result  := False;
  Exit;
 end;

 {Ctrl. Tabla}
 if (Length(Table_S) = 0) or (Table_S = '< Todas las Tablas >') then begin
  Retorno := 'Seleccionar la Tabla a ordenar.';
  Result  := False;
  Exit;
 end;

 {Ctrl. Index}
 if (Length(Index_S) = 0) or (Index_S = '< Orden Natural >') then begin
  Retorno := 'Seleccionar el Indice a ordenar.';
  Result  := False;
  Exit;
 end;

 {#  Configurar las tablas de origen y destino
  ## Config tables Source and Target}
 try
  with Table1 do begin
   Close;
   DatabaseName      := Alias_S;
   TableName         := Table_S;
   IndexName         := '';
   Open;
   RecordToCopy      := RecordCount;
   Close;
   IndexName         := Index_S;
   Open;
  end;

 except
  Table1.Close;
  Retorno := 'Error al copiar datos a la Tabla temporal.';
  Result  := False;
  Exit;
 end;

 if not CopyTableFull(Alias_S,      {Alias Source}
                      Table_S,      {Table Source}
                      'Tmp.Dbf',    {Table Target temporary}
                      Retorno)      {Message of result}
 then begin
  Retorno := 'Error producido al copiar ' + Alias_S + ' en tmp.dbf.';
  Result  := False;
  Exit;
 end;

 with Table2 do begin
  Close;
  DatabaseName := Alias_S;
  TableName    := 'Tmp.Dbf';
  IndexName    := Index_S;
 end;

 Table2.Open;
 Edit2.Text := IntToStr(Table2.RecordCount);
 Edit2.Refresh;

 {#  Ctrl. de que la tabla tiene registros antes de borrar la anterior
  ## Ctrl. of the fact that temporary table has records before erasing the previous}
 if Table2.RecordCount = 0 then begin
  Result  := False;
  Retorno := 'Error al aadir datos en to Tmp.dbf . 0 registros copiados';
  Exit;
 end;

 Table2.First;
 RecordCopy := 0;
 while not Table2.Eof do begin
  RecordCopy := RecordCopy + 1;
  Table2.Next;
 end;

 {# Control de que ha copiado menos registros de los que tenia en origen por ser un
    indice con clausula UNIQUE
 ## Control of the fact that it has copied less records of those which tape-worm
    in origin by be an  index with conditions UNIQUE}
 if RecordCopy < RecordToCopy then
  if MessageDlg('El Indice seleccionado tiene una clasula UNIQUE y se ' + #13 +
                'perderan datos. Cancelamos la operacin   ??',
                mtInformation, [mbYes, mbNo], 0) = mrYes then
  begin
   Result  := False;
   Retorno := 'Operacin abortada por tener clasula UNIQUE';
   Table2.Close;
   Exit;
  end;

 Table2.Close;

 {#  Borrar la tabla de origen despues de comprobar que hemos copiado todos los registros
  ## To erase table of origin after proving that we have copied the all records}
 try
  Table1.Close;
  Table1.Exclusive := True;
  Table1.Open;
  Table1.EmptyTable;
  Table1.Close;
  Table1.Exclusive := False;
  Table1.Open;
 except
  Table1.Close;
  Retorno := 'Error al borrar la Tabla ' + Table1.TableName;
  Result  := False;
  Exit;
 end;

 {#  Pasar los datos de la tabla temporal tmp.dbf-Table2 a Table1
  ## To happen the data of temporary table tmp.dbf-Table2 to Table1}
 Table2.Open;
 Table2.First;
 RecordCopy := 0;
 try
  while not Table2.Eof do begin
   Table1.Edit;
   Table1.Insert;
   for Field_Number := 0 to Table2.FieldCount - 1 do
    Table1.Fields[Field_Number].Assign(Table2.Fields[Field_Number]);

   Table1.Post;
   RecordCopy := RecordCopy + 1;
   Table2.next;
  end;
 except
  Table1.Close;
  Table2.Close;
  Retorno := 'Error al ordenar datos y copiar en ' + Table1.TableName;
  Result  := False;
  Exit;
 end;
 Retorno := 'Ordenacin de Tabla - ' + Table_S + ' - terminada.' +
            IntToStr(RecordCopy) + ' Registros copiados';
 Table1.Close;
 Table2.Close;
 Result  := True;

end;

function TCopia_Dbf.CopySort(Alias_S,Table_S,Index_S,Directory_T,Table_T :String;
                             var Retorno :String; TableType_T : TTableType):Boolean;
begin

 {Ctrl. Alias}
 if Length(Alias_S) = 0 then begin
  Retorno := ('Seleccionar el Alias o directorio de Datos.');
  Result  := False;
  Exit;
 end;

 {Ctrl. Tabla}
 if (Length(Table_S) = 0) or (Table_S = '< Todas las Tablas >') then begin
  Retorno := 'Seleccionar la Tabla a ordenar.';
  Result  := False;
  Exit;
 end;

 {#  Ctrl. Indice. Tambien es posible exportar la tabla por orden Natural
  ## Ctrl. Index. Also it is possible to export table by Orden Natural }
 if (Length(Index_S) = 0) or (Index_S = '< Orden Natural >') then begin
  Index_S := '';
 end;

 {#  Ctrl. de la extension del fichero. Se quita si la tiene
  ## Ctrl. of the extension of the file. It is acquittance if it has}
 if Pos('.',Table_T) > 0 then begin
  while Pos('.',Table_T) = 1 do Table_T := Copy(Table_T,2,Length(Table_T) - 1);
  while pos('.',Table_T) > 0 do Table_T := Copy(Table_T,1,Pos('.',Table_T)-1);
 end;

 {#  Configurar tablas
  ## Config Tables}
 try
  with Table1 do begin
   Close;
   DatabaseName := Alias_S;
   TableName    := Table_S;
   IndexName    := Index_S;
   Open;
  end;

  with Table2 do begin
   Close;
   DatabaseName := Directory_T;
   TableName    := Table_T;
   TableType    := TableType_T;
  end;

  {#  Realizar la copia de datos
   ## Execute the data copy

   ### The component TBatchMove has some Bug and not always works well.
       In some occasions and in the same conditions not copy nothing.}

  RecordCopy := Table2.BatchMove(Table1, BatCopy);
  Retorno    := 'Copia ordenada al fichero - ' + Table_T + ' - terminada. ' +
                IntToStr(RecordCopy) + ' Registros copiados.';
  Result     := True;
 except
  Table1.Close;
  Table2.Close;
  Result  := False;
  Retorno := 'Error al hacer la copia ordenada';
 end;
end;

procedure TCopia_Dbf.CbTipoTablaEnter(Sender: TObject);
begin
 CbTipoTabla.Color := clWhite;
end;

procedure TCopia_Dbf.CbTipoTablaExit(Sender: TObject);
begin
 CbTipoTabla.Color := clSilver;
end;

procedure TCopia_Dbf.CbTipoTablaKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 Directory1.SetFocus;
end;

function TCopia_Dbf.CopyTableFull(Alias_S, Table_S, Table_T: String; var Retorno :String): Boolean;
var
 pTable_S, pTable_T : array[0..80] of char;
 ResultCopy         : DBIResult;
begin
 {#  Table_T debe contener el Path completo de D.O.S. del fichero
  ## Table_T it must contain the full Path of D.O.S. of the file}

 Result := False;

 {#  Convertir de String a Pchar la tabla Destino
  ## To convert of String to Pchar the Destination table}
 StrPCopy(pTable_T, Table_T);

 {#  Configurar y Copiar la tabla
  ## Config and copy the table}
 with Table1 do begin
  try
   Close;
   DataBaseName := Alias_S;
   TableName    := Table_S;
   TableType    := ttDefault;
   StrPCopy(pTable_S, TableName);
   Open;

   ResultCopy   := DbiCopyTable(DBHandle, True, pTable_S, nil, pTable_T);
   Result       := not (ResultCopy <> DBIERR_NONE);
   if Result then Retorno      := 'Tabla - ' + Table_S + ' - ha sido copiada con xito'
   else Retorno := 'Error producido al copiar la tabla';
  except
   on E: EDBEngineError do Retorno := E.Message;
   on E: Exception      do Retorno := E.Message;
  end;
 end;
end;

procedure TCopia_Dbf.Directory1Change(Sender: TObject);
begin
 EditDirectory.Text := Directory1.Directory;
 if Copy(EditDirectory.Text,Length(EditDirectory.Text),1) <> '\'
 then EditDirectory.Text := EditDirectory.Text + '\';
 EditDirectory.Refresh;
end;

procedure TCopia_Dbf.BBSQLClick(Sender: TObject);
begin
 Ejecutar1Click(nil);
end;

procedure TCopia_Dbf.TN1Click(Sender: TObject);
var Table_S,Index_S : String;
begin

 if TN1.ActivePage = 'Datos' then begin

  Table_S := AllTrim(CbTable.Items[CbTable.ItemIndex]);
  Index_S := AllTrim(CbIndex.Items[CbIndex.ItemIndex]);

  Table1.Close;
  Table1.DatabaseName := CbAlias.Items[CbAlias.ItemIndex];

  if (Table_S <> '< Todas las Tablas >') and (Length(LTrim(Table_S)) > 0) then
   Table1.TableName    := Table_S
  else Exit;

  if (Index_S <> '< Orden Natural >') and (Length(LTrim(Index_S)) > 0) then
   Table1.IndexName   := Index_S;

  Table1.Open;
  Table1.Active       := True;
  DbGrid2.Refresh;
  EditRegistro.Text := IntToStr(Recno(Table1));
 end;
end;

procedure TCopia_Dbf.TablassinIndices1Click(Sender: TObject);
var
 Contador : Integer;
begin
{Copiar - Tablas sin Indices. Solo los datos}
 InicioCopia;

 if CbTable.ItemIndex > 0 then begin
  if Length(AllTrim(Directory1.Directory)) > 2 then begin
   Mensaje('Copying ' + CbTable.Items[CbTable.ItemIndex]);

   if Length(AllTrim(EditFic.Text)) = 0 then EditFic.Text := CbTable.Items[CbTable.ItemIndex];

   if not CopySort(CbAlias.Items[CbAlias.ItemIndex], {Alias Source}
                   CbTable.Items[CbTable.ItemIndex], {Table Source}
                   '',                               {Index Source}
                   Directory1.Directory,             {Alias Target}
                   AllTrim(EditFic.Text),            {Table Target}
                   Retorno,                          {Message of result}
                   TableType_T)                      {Table Type to copy}

   then MessageDlg('Unable to Copying ' + CbTable.Items[ CbTable.ItemIndex ] +
                   '.  Motive: ' +  '. ' + #10 + #10 + Retorno, mtError, [mbOK], 0);

  end else ShowMessage('Debe de indicarse el Directorio de destino.');

 end else begin
  NTablas := CbTable.Items.Count;
  for Contador := 1 to CbTable.Items.Count - 1 do begin
   Mensaje('Copying ' + CbTable.Items[Contador]);
   Edit2.Text := IntToStr(NTablas - Contador);
   Edit2.Refresh;

   if Length(AllTrim(Directory1.Directory)) > 2 then begin
    if not CopySort(CbAlias.Items[CbAlias.ItemIndex], {Alias Source}
                    CbTable.Items[Contador],          {Table Source}
                    '',                               {Index Source}
                    Directory1.Directory,             {Alias Target}
                    CbTable.Items[Contador],          {Table Target}
                    Retorno,                          {Mensaje de resultado}
                    TableType_T)                      {Tipo de Tabla a copiar}
    then MessageDlg('Imposible copiar ' + CbTable.Items[Contador] +
                      '.  Motivo: ' +  '. ' + #10 + #10 + Retorno, mtError, [mbOK], 0);

   end else ShowMessage('Debe de indicarse el Directorio de destino.');

   Edit2.Text := '';
   Edit2.Refresh;
  end;
  Mensaje('Copia terminada.');
 end;
end;

procedure TCopia_Dbf.InicioCopia;
begin
 DbiInit(nil);
 Retorno := ''; {# Mensajes Ok o Nok devueltos por las funciones
                 ## Messages Ok or Nok returned by the functions}
 Mensaje('');

 {TableType Target}
 if      CbTipoTabla.Text = 'dBase'   then TableType_T := ttDBase
 else if CbTipoTabla.Text = 'Paradox' then TableType_T := ttParadox
 else if CbTipoTabla.Text = 'ASCII'   then TableType_T := ttASCII;
end;

procedure TCopia_Dbf.TablaporunIndice1Click(Sender: TObject);
begin
 (*
 {Se incluye la funcin original del Bde que permite ordenar por un campo, pero
  no se utiliza en este ejemplo}
 function fDbiSortTable(SrcTbl, DestTbl: TTable; SortField: TField): longint;
 *)

 {Ordenar - Tabla por un Indice}
 InicioCopia;

 Alias_S := AllTrim(CbAlias.Items[CbAlias.ItemIndex]);
 Table_S := AllTrim(CbTable.Items[CbTable.ItemIndex]);
 Index_S := AllTrim(CbIndex.Items[CbIndex.ItemIndex]);

 {#  La funcion de ordenar SortTable devuelve 1 si tiene exito y 0 si falla
  ## The function of ordering SortTable() returns 1 if has sucess and 0 if defect}
 if not SortTable(Alias_S, Table_S, Index_S, Retorno) then begin
  ShowMessage(Retorno);
  Exit;
 end else begin
  Edit1.Text  := Retorno;
  Edit1.Color := clWhite;
 end;
 Exit;
end;

procedure TCopia_Dbf.FiltroSQL1Click(Sender: TObject);
var
 k : Integer;
begin
 InicioCopia;
 {Exportar - Filtro de Query - SQL
  ## To export by the Query SQL Filter}

 {Ctrl de la existencia del nombre del fichero}
 if Length(AllTrim(EditFic.Text)) = 0 then begin
  ShowMessage('Debe indicarse el fichero de destino.');
  Exit;
 end;

 if Length(Directory1.Directory) < 3 then begin
  Directory1.SetFocus;
  Exit;
 end;

 {Execute Query}
 BBSQLClick(nil);
 if StrToInt(EditRecordQuery.Text) = 0 then begin
  ShowMessage('No hay registros procedentes del filtro SQL para copiar.');
  Exit;
 end;

(* Procedimiento antiguo utilizando las funciones de copiar tablas
 {Copy the Table}
 Alias_S     := AllTrim(CbAlias.Items[CbAlias.ItemIndex]);
 Table_S     := AllTrim(CbTable.Items[CbTable.ItemIndex]);
 Index_S     := AllTrim(CbIndex.Items[CbIndex.ItemIndex]);
 Directory_T := AllTrim(Directory1.Directory);
 Table_T     := AllTrim(EditFic.Text);

 if not CopySort(Alias_S, Table_S, Index_S, Directory_T,
                 Table_T, Retorno, TableType_T) then begin
  ShowMessage(Retorno);
  Exit;
 end else begin
  Edit1.Text  := Retorno;
  Edit1.Color := clWhite;
 end;

 {#  Vaciar la tabla destino
  ## Empty the Table Target}
 with Table2 do begin
  Close;
  Exclusive    := True;
  DatabaseName := Directory_T;
  TableName    := Table_T;
  TableType    := TableType_T;
  EmptyTable;
  Close;
 end;

*)

{Crear la nuava tabla en el directorio indicado}
 with Table2 do begin
  Close;
  DataBaseName := Directory1.Directory;
  TableName    := AllTrim(EditFic.Text);
  TableType    := TableType_T;
  FieldDefs.clear;
  for k := 0 to Query1.FieldDefs.Count-1 do
   FieldDefs.Add(Query1.FieldDefs.Items[k].Name,
                 Query1.FieldDefs.Items[k].DataType,
                 Query1.FieldDefs.Items[k].Size,
                 Query1.FieldDefs.Items[k].Required);
  IndexDefs.Clear;
 end;
 try
  Table2.CreateTable;
 except
  MessageDlg( 'Ha ocurrido un error creando la tabla', mtError,[mbCancel], 0 );
 end;

 {#  Ejecutar la copia del query
  ## Execute the query copy}
 BMove1.Execute;

 Table2.Open;
 Edit1.Text := 'Proceso de copia de filtro SQL terminado. ' +
               IntToStr(Table2.RecordCount) +
               ' registros copiados';
 Table2.Close;
 TN1.ActivePage := 'Filtros';
end;

procedure TCopia_Dbf.Tablaordebnada1Click(Sender: TObject);
begin
 {Exportar - Tabla Ordenada}
 InicioCopia;

 {Ctrl de la existencia del nombre del fichero}
 if Length(AllTrim(EditFic.Text)) = 0 then begin
  ShowMessage('Necesito conocer el fichero de destino.');
  Exit;
 end;

 {Ctrl. Directory Target}
 EditDirectory.Text := AllTrim(EditDirectory.Text);

 if Length(EditDirectory.Text) < 3 then begin
  Directory1.SetFocus;
  Exit;
 end;

 Alias_S     := AllTrim(CbAlias.Items[CbAlias.ItemIndex]);
 Table_S     := AllTrim(CbTable.Items[CbTable.ItemIndex]);
 Index_S     := AllTrim(CbIndex.Items[CbIndex.ItemIndex]);
 Directory_T := AllTrim(Directory1.Directory);
 Table_T     := AllTrim(EditFic.Text);

 if not CopySort(Alias_S, Table_S, Index_S, Directory_T,
                 Table_T, Retorno, TableType_T) then begin
  ShowMessage(Retorno);
  Exit;
 end else begin
  Edit1.Text  := Retorno;
  Edit1.Color := clWhite;
 end;
end;

procedure TCopia_Dbf.TablasIndices1Click(Sender: TObject);
var
 Contador : Integer;
begin
 {Copiar - Tablas completas. dbf + mdx}
 InicioCopia;

 if CbTable.ItemIndex > 0 then begin
  {Copy an table}
  if Length(AllTrim(Directory1.Directory)) > 2 then begin
   Mensaje('Copying ' + CbTable.Items[CbTable.ItemIndex]);

   if Length(AllTrim(EditFic.Text)) = 0 then EditFic.Text := CbTable.Items[CbTable.ItemIndex];

    if not CopyTableFull(CbAlias.Items[CbAlias.ItemIndex],      {Alias Source}
                         CbTable.Items[CbTable.ItemIndex],      {Table Source}
                         EditDirectory.Text + AllTrim(EditFic.Text),{Alias + Table Target}
                         Retorno)                               {Message of result}
    then MessageDlg('Unable to Copying ' + CbTable.Items[ CbTable.ItemIndex ] +
                    '.  Motive: ' +  '. ' + #10 + #10 + Retorno, mtError, [mbOK], 0);

  end else ShowMessage('Debe de indicarse el Directorio de destino.');

 end else begin
  NTablas := CbTable.Items.Count;
  for Contador := 1 to CbTable.Items.Count - 1 do begin
   Mensaje('Copying ' + CbTable.Items[Contador]);
   Edit2.Text := IntToStr(NTablas - Contador);
   Edit2.Refresh;
   if Length(AllTrim(Directory1.Directory)) > 2 then begin
    if not CopyTableFull(CbAlias.Items[CbALias.ItemIndex],
                         CbTable.Items[Contador],
                         EditDirectory.Text + CbTable.Items[Contador],
                         Retorno)
    then MessageDlg('Imposible copiar ' + CbTable.Items[ CbTable.ItemIndex ] +
                    '.  Motivo: ' +  '. ' + #10 + #10 + Retorno, mtError, [mbOK], 0);
   end else ShowMessage('Debe de indicarse el Directorio de destino.');
  end;

  Edit2.Text := '';
  Edit2.Refresh;
 end;
 Mensaje('Copia terminada.');

end;

procedure TCopia_Dbf.Ejecutar1Click(Sender: TObject);
begin
  try
   Screen.Cursor := crHourglass;
   if Query1.Active then Query1.Close;
   Query1.DatabaseName := AllTrim(CbAlias.Items[CbAlias.ItemIndex]);
   Query1.SQL.clear;
   Query1.SQL.Add(Memo1.Text);
   Query1.Active := True;
   Screen.Cursor := crDefault;

   if Query1.Active then begin
    { If the query didn't return any records, there's no point in
    displaying the form.  In that event, raise an exception. }
    if Query1.RecordCount < 1 then
     ShowMessage('No hay datos para el criterio seleccionado.');
   end;
  finally
   Screen.Cursor := crDefault;
  end;
 EditRecordQuery.Text := IntToStr(Query1.RecordCount);
 TN1.ActivePage := 'Query';
end;

procedure TCopia_Dbf.Salir1Click(Sender: TObject);
begin
 Close;
end;

procedure TCopia_Dbf.Timer1Timer(Sender: TObject);
var
 InformacionSistema: SYSInfo;
 InformacionConfiguracion: SYSConfig;
begin
 {Procedimiento procedente del libro de Fernando Charte,
                                        Programacin avanzada con Delphi 2}

 { Obtenemos informacin actualizada }
 DbiGetSysInfo(InformacionSistema);
 DbiGetSysConfig(InformacionConfiguracion);

 { y la mostramos en los controles dispuesto en la ficha para tal fin }
 with InformacionSistema do begin
  Buffer.Text        := IntToStr(iBufferSpace);
  Heap.Text          := IntToStr(iHeapSpace);
  Controladores.Text := IntToStr(iDrivers);
  Clientes.Text      := IntToStr(iClients);
  Sesiones.Text      := IntToStr(iSessions);
  BasesDatos.Text    := IntToStr(iDatabases);
  Cursores.Text      := IntToStr(iCursors);
 end;

 with InformacionConfiguracion do begin
  if bLocalShare then Compartir.Text := 'SI' else Compartir.Text := 'NO';

  TipoRed.Text              := szNetType;
  NombreUsuario.Text        := szUserName;
  ArchivoConfiguracion.Text := szIniFile;
  ControladorLenguaje.Text  := szLangDriver;
 end;
end;

procedure TCopia_Dbf.BitBtn1Click(Sender: TObject);
begin
 DbiInit(nil); {Inicializar el BDE}
end;


procedure TCopia_Dbf.BitBtn2Click(Sender: TObject);
begin
 DbiExit; {Cerrar el BDE}
end;

procedure TCopia_Dbf.CBIndexChange(Sender: TObject);
function BoolVal(InBool: Boolean): String;
  begin
    if InBool = True then Result:= 'True'
    else Result:= 'False';
  end;

var
 IndexDesc : IDXDesc;
 KeyArray  : String;
 x         : Integer;
begin
 Table1.Open;
 EditIndex.Text := CbIndex.Items[CbIndex.ItemIndex];
 {Obtener los datos relativos a cada uno de los indices}
 if EditIndex.Text <> '< Orden Natural >' then begin
  Table1.IndexName := EditIndex.Text;
  DbiGetIndexDesc(Table1.Handle,0,IndexDesc);
  IndexInfo.Clear;
  IndexInfo.Items.Add('Key Expression : ' + IndexDesc.szKeyExp);
  IndexInfo.Items.Add('Index Name : ' + IndexDesc.szname);
  IndexInfo.Items.Add('Tag Name (dBASE) : ' + IndexDesc.szTagName);
  IndexInfo.Items.Add('Index Format : ' + IndexDesc.szformat);
  IndexInfo.Items.Add('Primary : ' + BoolVal(IndexDesc.bPrimary));
  IndexInfo.Items.Add('Descending : ' + BoolVal(IndexDesc.bDescending));
  IndexInfo.Items.Add('Maintained : ' + BoolVal(IndexDesc.bMaintained));
  IndexInfo.Items.Add('Subset : ' + BoolVal(IndexDesc.bSubset));
  IndexInfo.Items.Add('ExpIdx : ' + BoolVal(IndexDesc.bExpIdx));
  IndexInfo.Items.Add('Fields In Key : ' + IntToStr(IndexDesc.iFldsInKey));
  IndexInfo.Items.Add('Key Length : ' + IntToStr(IndexDesc.iKeyLen));
  IndexInfo.Items.Add('Out of Date : ' + BoolVal(IndexDesc.bOutofDate));
  IndexInfo.Items.Add('Key Expression Type : ' + IntToStr(IndexDesc.iKeyExpType));
  KeyArray := '';
  for x:= 0 to IndexDesc.iFldsInKey -1 do
    KeyArray := KeyArray + IntToStr(IndexDesc.aiKeyFld[x]) + ', ';
  IndexInfo.Items.Add('Field Numbers used in Key : ' + KeyArray);
  IndexInfo.Items.Add('Key Condition : ' + IndexDesc.szKeyCond);

  IndexInfo.Items.Add('Case Insensitive : ' + BoolVal(IndexDesc.bCaseInsensitive));
  IndexInfo.Items.Add('iBlockSize : ' + IntToStr(IndexDesc.iBlockSize));
  IndexInfo.Items.Add('iRestrNum : ' + IntToStr(IndexDesc.iRestrNum));
  IndexInfo.Text := 'Key Expression : ' + IndexDesc.szKeyExp;
 end;
 Table1.Close;
end;

procedure TCopia_Dbf.Filtros1Click(Sender: TObject);
begin
 TN1.ActivePage := 'Filtros';
end;

procedure TCopia_Dbf.Sql1Click(Sender: TObject);
begin
 TN1.ActivePage := 'Datos';
end;

procedure TCopia_Dbf.Query2Click(Sender: TObject);
begin
 TN1.ActivePage := 'Query';
end;

procedure TCopia_Dbf.Estructura1Click(Sender: TObject);
begin
 TN1.ActivePage := 'Bde';
end;

procedure TCopia_Dbf.Explorer1Click(Sender: TObject);
begin
 TN1.ActivePage := 'Explorer';
end;

function TCopia_Dbf.fDbiPackTable(TblName : TTable; bRegenIdxs: Boolean;
                              var Retorno : String): Boolean;
var
 BdeResult : DbiResult;
 hDb       : hDBIDb;
begin
(*
 {Ejemplo de llamar a la funcin}
 Table1.Close;
 Table1.Exclusive := True;
 Table1.Open;
 {Solo para tablas dBase. para Paradox, adaptarlo}
 if not fDbiPackTable(Table1,
                      True,      {Indexar al finalizar, True o False}
                      Retorno) then ShowMessage(Retorno);
*)
 Edit1.Text := 'Empaquetando ' + TblName.TableName;
 Edit1.Refresh;
 BdeResult := DbiPackTable(hDb, TblName.Handle, nil,nil, bRegenIdxs);
 Case BdeResult of
  DBIERR_NONE           : Retorno := 'Todos los Indices de la tabla han sido Indexados';
  DBIERR_INVALIDHNDL    : Retorno := 'El Nombre de la Tabla o el puntero a la misma es Nulo';
  DBIERR_NOSUCHTABLE	: Retorno := 'La Tabla ' + TblName.TableName + ' no Existe';
  DBIERR_UNKNOWNTBLTYPE	: Retorno := 'El tipo de tabla es desconocido';
  DBIERR_NEEDEXCLACCESS : Retorno := 'La Tabla '  + TblName.TableName + ' debe estar abierta en modo Exclusivo';
 else
  Retorno := 'El BDE retorna un error inexperado';
 end;
 Result := (BdeResult = DBIERR_NONE);
end;

function TCopia_Dbf.fDbiRegenIndexes(TblName : TTable ; var Retorno : String): Boolean;
var
 BdeResult : DbiResult;
begin
(*
{Ejemplo de llamar a la funcin }
 Table1.Close;
 Table1.Exclusive := True;
 Table1.Open;
 if not fDbiRegenIndexes(Table1, Retorno) then ShowMessage(Retorno);
 *)

 BdeResult := DbiRegenIndexes(TblName.Handle);
 Case BdeResult of
  DBIERR_NONE           : Retorno := 'Todos los Indices de la tabla han sido Indexados';
  DBIERR_INVALIDHNDL    : Retorno := 'El cursor Handle no es valido o es nulo.';
  DBIERR_NEEDEXCLACCESS : Retorno := 'La Tabla '  + TblName.TableName + ' debe estar abierta en modo Exclusivo';
  DBIERR_NOTSUPPORTED   : Retorno := 'DbiRegenIndexes no soporta tablas SQL';
 else
  Retorno := 'El BDE retorna un error inexperado';
 end;
 Result := (BdeResult =DBIERR_NONE);
end;

procedure TCopia_Dbf.Indexar1Click(Sender: TObject);
var
 Contador, NTablas : Integer;
begin
 TN1.ActivePage := 'Filtros';

 if CbTable.Items.Count = 1 then Exit; {No hay tablas para reindexar}

 if (CbTable.Items[CbTable.ItemIndex] <> '< Todas las Tablas >') then begin {Indexar una sola Tabla}
  Retorno := '';
  Table1.Close;
  Table1.DataBaseName := CbAlias.Items[CbAlias.ItemIndex];
  Table1.TableName    := CbTable.Items[CbTable.ItemIndex];
  Table1.Exclusive    := True;
  Table1.Open;
  Edit1.Text          := ' Indexando la Tabla ' + Table1.TableName;
  Edit1.Refresh;

  if not fDbiRegenIndexes(Table1, Retorno) then ShowMessage(Retorno);

 end else begin {Indexar todas las tablas}
  NTablas             := cbTable.Items.Count;
  for Contador := 1 to NTablas - 1 do begin
   Table1.Close;
   Table1.DataBaseName := CbAlias.Items[CbAlias.ItemIndex];
   Table1.TableName    := CbTable.Items[Contador];
   Table1.Exclusive    := True;
   Table1.Open;
   Edit1.Text          := ' Indexando la Tabla ' + Table1.TableName;
   Edit2.Text          := IntToStr(Contador);
   Edit1.Refresh;
   Edit2.Refresh;

   if not fDbiRegenIndexes(Table1, Retorno) then ShowMessage(Retorno);

  end;
 end;

 Table1.CLose;
 Table1.Exclusive := False;
 Table1.Open;

 Edit2.Text := '';
 Edit1.Text       := 'Reindexacin Terminada.' + IntToStr(Contador) + ' Registros indexados';
end;

procedure TCopia_Dbf.Empaquetar1Click(Sender: TObject);
var
 Contador, NTablas : Integer;
begin
 TN1.ActivePage := 'Filtros';

 if CbTable.Items.Count = 1 then Exit; {No hay tablas para Empaquetar}

 if (CbTable.Items[CbTable.ItemIndex] <> '< Todas las Tablas >') then begin {Empaquetar una sola Tabla}
  Retorno := '';
  Table1.Close;
  Table1.DataBaseName := CbAlias.Items[CbAlias.ItemIndex];
  Table1.TableName    := CbTable.Items[CbTable.ItemIndex];
  Table1.Exclusive    := True;
  Table1.Open;
  Edit1.Text          := ' Indexando la Tabla ' + Table1.TableName;
  Edit1.Refresh;

  if not fDbiPackTable(Table1,
                       True,      {Indexar al finalizar, True o False}
                       Retorno) then ShowMessage(Retorno);

 end else begin {Empaquetar todas las tablas}
  NTablas             := cbTable.Items.Count;
  for Contador := 1 to NTablas - 1 do begin
   Table1.Close;
   Table1.DataBaseName := CbAlias.Items[CbAlias.ItemIndex];
   Table1.TableName    := CbTable.Items[Contador];
   Table1.Exclusive    := True;
   Table1.Open;
   Edit1.Text          := ' Empaquetando la Tabla ' + Table1.TableName;
   Edit2.Text          := IntToStr(Contador);
   Edit1.Refresh;
   Edit2.Refresh;

   if not fDbiPackTable(Table1,
                        True,      {Indexar al finalizar, True o False}
                        Retorno) then ShowMessage(Retorno);

  end;
 end;

 Table1.CLose;
 Table1.Exclusive := False;
 Table1.Open;

 Edit2.Text := '';
 Edit1.Text       := 'Empaquetado terminado. ' + IntToStr(Contador) + ' tablas empaquetadas';
end;

function TCopia_Dbf.GetFieldType(Tipo: TFieldType): string;
const
{$IFDEF WIN32}
 Types: array [ftUnknown..ftTypedBinary] of string [11] =
        ('Unknown', 'String', 'Smallint', 'Integer', 'Word', 'Boolean', 'Float',
         'Currency','BCD', 'Date', 'Time', 'DateTime', 'Bytes', 'VarBytes',
         'AutoInc','Blob', 'Memo', 'Graphic','FmtMemo','ParadoxOle','DBaseOle','TypedBinary');
{$ELSE}
 Types: array [ftUnknown..ftGraphic] of string [8] =
        ('Unknown', 'String', 'Smallint', 'Integer', 'Word', 'Boolean', 'Float',
         'Currency','BCD', 'Date', 'Time', 'DateTime', 'Bytes', 'VarBytes',
         'Blob', 'Memo', 'Graphic');
{$ENDIF}
begin
  if (Tipo < Low(Types)) or (Tipo > High(Types)) then Tipo := Low(Types);
  Result := Types[Tipo];
end;

procedure TCopia_Dbf.Acercade1Click(Sender: TObject);
begin
 ShowMessage('CopySort Version 1.3' + #13 +
             'Autor: Jose Maria Gias' + #13 +
             'j.m.gias@arrakis.es' + #13 +
             'Freeware 14.06.97');
end;

function TCopia_Dbf.Recno(ATable: TTable): Longint;
var
  CP: CurProps;
  RP: RecProps;
begin
 with ATable do begin
  { Make sure it is a Paradox table!}
  UpdateCursorPos;                { sync BDE with Delphi}
  { Find out if table support Seq nums or Physical Rec nums}
  Check(DbiGetCursorProps(Handle, CP));
  Check(DbiGetRecord(Handle, dbiNOLOCK, nil, @RP));
  if StrComp(CP.szTableType, szDBASE) = 0 then
   Result := RP.iPhyRecNum
  else
   if StrComp(CP.szTableType, szPARADOX) = 0 then
    Result := RP.iSeqNum
   else
    { raise exception if it's not a Paradox or dBASE table}
    raise EDatabaseError.Create('Not a Paradox or dBASE table');
 end;
end;

procedure TCopia_Dbf.DS1DataChange(Sender: TObject; Field: TField);
begin
  EditRegistro.Text := IntToStr(Recno(Table1));
end;

procedure TCopia_Dbf.CheckBox1Click(Sender: TObject);
begin
 if CheckBox1.Checked then begin
  Query1.RequestLive := True;
  DbGrid1.ReadOnly   := False;
 end else begin
  Query1.RequestLive := False;
  DbGrid1.ReadOnly   := True;
 end;
end;

procedure TCopia_Dbf.EditNearChange(Sender: TObject);
var
 k      : Integer;
 Existe : Boolean;
begin
 Existe := False;
 {Control de la existencia del indice del campo}
 for k := 1 to SGrid1.RowCount do
  if UpperCase(AllTrim(sGrid1.Cells[0,k])) = UpperCase(AllTrim(EditIndex.Text)) then
   Existe := True;

 if not Existe then begin
  ShowMessage('En este proyecto solo se puede buscar por indices de un campo');
  Exit;
 end;

 EditRanStart.Text := '';
 EditRanEnd.Text   := '';

 {Ejemplo de aplicar busqueda blanda conforme escribimos texto}
  with Table1 do begin
   CancelRange;
   SetKey;
   FieldByName(AllTrim(EditIndex.Text)).AsString := AllTrim(EditNear.Text);
   GotoNearest;
  end;
end;

procedure TCopia_Dbf.SpeedButton1Click(Sender: TObject);
var
 k      : Integer;
 Existe : Boolean;
 Tipo   : String;
begin
 Existe := False;
 Tipo := '';
 {Control de la existencia del indice del campo}
 for k := 1 to SGrid1.RowCount do
  if UpperCase(AllTrim(sGrid1.Cells[0,k])) = UpperCase(AllTrim(EditIndex.Text))
  then begin
   Existe := True;
   Tipo   := sGrid1.Cells[1,k];
  end;

 if not Existe then begin
  ShowMessage('En este proyecto solo se puede buscar por indices de un campo');
  Exit;
 end;

 {Para esta aplicacin, solo se filtran los campos String}
 if Tipo <> 'String' then begin
  ShowMessage('En este proyecto solo se puede filtrar campos tipo String.');
  Exit;
 end;

 {Control de la existencia de texto a filtrar}
 if (Length(AllTrim(EditRanStart.Text)) = 0) then begin
  ShowMessage('Se necesita conocer el texto a filtrar.');
 end;

 {Ejemplo de aplicar filtros de datos }
  with Table1 do begin
   CancelRange;

   SetRangeStart;
   FieldByName(AllTrim(EditIndex.Text)).AsString := AllTrim(EditRanStart.Text);

   if (Length(AllTrim(EditRanEnd.Text)) > 0) then begin
    SetRangeEnd;
    FieldByName(AllTrim(EditIndex.Text)).AsString := AllTrim(EditRanEnd.Text);
   end;

   ApplyRange;
  end;
end;

procedure TCopia_Dbf.EditRanStartKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 EditNear.Text := '';
end;

procedure TCopia_Dbf.PrintSqlClick(Sender: TObject);
var
 k   : Integer;
 f : System.Text;
 Cad : String;
begin

 if not Query1.Active then begin
  ShowMessage('No tengo registros para imprimir.');
  Exit;
 end;
 if Query1.RecordCount = 0 then begin
  ShowMessage('No hay registros procedentes del filtro SQL para copiar.');
  Exit;
 end;

 Screen.Cursor            := CrHourGlass;
 Printer.Canvas.Font.Name := 'Courier';
 Printer.Canvas.Font.Size := 9;
 try
  AssignPrn(f);
  Rewrite(f);

  {Cabecera y Query}
  WriteLn(f,'Listado de Query') ;
  WriteLn(f,'----------------');
  WriteLn(f,Memo1.Text);
  WriteLn(f,'');

  {Campos y sus tipos}
  Cad := '';
  WriteLn(f,'Definicin de Campos');
  WriteLn(f,'--------------------');
  for k := 0 to Query1.FieldDefs.Count-1 do begin
   Cad := AlineaIzqda(IntToStr(k+1),4) + '  ' +
          AlineaIzqda(Query1.FieldDefs.Items[k].Name,20) + '  ' +
          AlineaIzqda(GetFieldType(Query1.FieldDefs.Items[k].DataType),10) + '  ' +
          AllTrim(IntToStr(Query1.FieldDefs.Items[k].Size));
   WriteLn(f,Cad);
  end;
  WriteLn(f,'');

  {Datos del Query}
  WriteLn(f,'Datos');
  WriteLn(f,'-----');
  Query1.First;
  Query1.DisableControls;
  while not Query1.Eof do begin
   Cad := '';
   for k := 0 to Query1.FieldDefs.Count - 1 do
    Cad := Cad +  AlineaIzqda(Query1.Fields[k].AsString,
                              Query1.FieldDefs.Items[k].Size) + '  ';

   WriteLn(f,Cad);
   Query1.Next;
  end;

  System.Close(f);
 except
  ShowMessage('Se ha producido una excepcin al realizar el listado');
 end;

 Query1.First;
 Query1.EnableControls;
 Screen.Cursor  := CrDefault;

end;

procedure TCopia_Dbf.Imprimir1Click(Sender: TObject);
begin
 PrintSqlClick(nil);
end;

{Esta es la funcion original del BDE que permite ordenar por un Campo de la tabla.
 Se incluye en el ejemplo, pero no se utiliza}
function TCopia_Dbf.fDbiSortTable(SrcTbl, DestTbl: TTable; SortField: TField): longint;
var
  Field: Word;
  CaseIns: boolean;
  Recs: longint;

begin
  Recs := SrcTbl.RecordCount;
  CaseIns := True;
  Field := SortField.Index + 1;

  if DestTbl.Active = False then
    raise EDatabaseError.Create('Cannot complete operation with destination table closed');

  Check(DbiSortTable(SrcTbl.DBHandle, nil, nil, SrcTbl.Handle, nil, nil,
           DestTbl.Handle, 1, @Field, @CaseIns, nil, nil, False, nil, Recs));

  Result := Recs;
end;

end.
